/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.games.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.json.JsonString;

/**
 * This is a JSON template for an achievement object.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Play Game Services API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class PlayerAchievement extends GenericJson {

  /**
   * The state of the achievement. Possible values are:   - "HIDDEN" - Achievement is hidden.  -
   * "REVEALED" - Achievement is revealed.  - "UNLOCKED" - Achievement is unlocked.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String achievementState;

  /**
   * The current steps for an incremental achievement.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Integer currentSteps;

  /**
   * The current steps for an incremental achievement as a string.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String formattedCurrentStepsString;

  /**
   * The ID of the achievement.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String id;

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#playerAchievement.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The timestamp of the last modification to this achievement's state.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private Long lastUpdatedTimestamp;

  /**
   * The state of the achievement. Possible values are:   - "HIDDEN" - Achievement is hidden.  -
   * "REVEALED" - Achievement is revealed.  - "UNLOCKED" - Achievement is unlocked.
   * The value returned may be {@code null}.
   */
  public String getAchievementState() {
    return achievementState;
  }

  /**
   * The state of the achievement. Possible values are:   - "HIDDEN" - Achievement is hidden.  -
   * "REVEALED" - Achievement is revealed.  - "UNLOCKED" - Achievement is unlocked.
   * The value set may be {@code null}.
   */
  public PlayerAchievement setAchievementState(String achievementState) {
    this.achievementState = achievementState;
    return this;
  }

  /**
   * The current steps for an incremental achievement.
   * The value returned may be {@code null}.
   */
  public Integer getCurrentSteps() {
    return currentSteps;
  }

  /**
   * The current steps for an incremental achievement.
   * The value set may be {@code null}.
   */
  public PlayerAchievement setCurrentSteps(Integer currentSteps) {
    this.currentSteps = currentSteps;
    return this;
  }

  /**
   * The current steps for an incremental achievement as a string.
   * The value returned may be {@code null}.
   */
  public String getFormattedCurrentStepsString() {
    return formattedCurrentStepsString;
  }

  /**
   * The current steps for an incremental achievement as a string.
   * The value set may be {@code null}.
   */
  public PlayerAchievement setFormattedCurrentStepsString(String formattedCurrentStepsString) {
    this.formattedCurrentStepsString = formattedCurrentStepsString;
    return this;
  }

  /**
   * The ID of the achievement.
   * The value returned may be {@code null}.
   */
  public String getId() {
    return id;
  }

  /**
   * The ID of the achievement.
   * The value set may be {@code null}.
   */
  public PlayerAchievement setId(String id) {
    this.id = id;
    return this;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#playerAchievement.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#playerAchievement.
   * The value set may be {@code null}.
   */
  public PlayerAchievement setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The timestamp of the last modification to this achievement's state.
   * The value returned may be {@code null}.
   */
  public Long getLastUpdatedTimestamp() {
    return lastUpdatedTimestamp;
  }

  /**
   * The timestamp of the last modification to this achievement's state.
   * The value set may be {@code null}.
   */
  public PlayerAchievement setLastUpdatedTimestamp(Long lastUpdatedTimestamp) {
    this.lastUpdatedTimestamp = lastUpdatedTimestamp;
    return this;
  }

}
