/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.games.model;

import com.google.api.client.json.GenericJson;

/**
 * This is a JSON template for a list of leaderboard entry resources.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Play Game Services API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class PlayerScoreResponse extends GenericJson {

  /**
   * The time spans where the submitted score is better than the existing score for that time span.
   * Possible values are:   - "ALL_TIME" - The score is an all-time score.  - "WEEKLY" - The score
   * is a weekly score.  - "DAILY" - The score is a daily score.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<String> beatenScoreTimeSpans;

  /**
   * The formatted value of the submitted score.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String formattedScore;

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#playerScoreResponse.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The leaderboard ID that this score was submitted to.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String leaderboardId;

  /**
   * The scores in time spans that have not been beaten. As an example, the submitted score may be
   * better than the player's DAILY score, but not better than the player's scores for the WEEKLY or
   * ALL_TIME time spans.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<PlayerScore> unbeatenScores;

  static {
    // hack to force ProGuard to consider PlayerScore used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(PlayerScore.class);
  }

  /**
   * The time spans where the submitted score is better than the existing score for that time span.
   * Possible values are:   - "ALL_TIME" - The score is an all-time score.  - "WEEKLY" - The score
   * is a weekly score.  - "DAILY" - The score is a daily score.
   * The value returned may be {@code null}.
   */
  public java.util.List<String> getBeatenScoreTimeSpans() {
    return beatenScoreTimeSpans;
  }

  /**
   * The time spans where the submitted score is better than the existing score for that time span.
   * Possible values are:   - "ALL_TIME" - The score is an all-time score.  - "WEEKLY" - The score
   * is a weekly score.  - "DAILY" - The score is a daily score.
   * The value set may be {@code null}.
   */
  public PlayerScoreResponse setBeatenScoreTimeSpans(java.util.List<String> beatenScoreTimeSpans) {
    this.beatenScoreTimeSpans = beatenScoreTimeSpans;
    return this;
  }

  /**
   * The formatted value of the submitted score.
   * The value returned may be {@code null}.
   */
  public String getFormattedScore() {
    return formattedScore;
  }

  /**
   * The formatted value of the submitted score.
   * The value set may be {@code null}.
   */
  public PlayerScoreResponse setFormattedScore(String formattedScore) {
    this.formattedScore = formattedScore;
    return this;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#playerScoreResponse.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#playerScoreResponse.
   * The value set may be {@code null}.
   */
  public PlayerScoreResponse setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The leaderboard ID that this score was submitted to.
   * The value returned may be {@code null}.
   */
  public String getLeaderboardId() {
    return leaderboardId;
  }

  /**
   * The leaderboard ID that this score was submitted to.
   * The value set may be {@code null}.
   */
  public PlayerScoreResponse setLeaderboardId(String leaderboardId) {
    this.leaderboardId = leaderboardId;
    return this;
  }

  /**
   * The scores in time spans that have not been beaten. As an example, the submitted score may be
   * better than the player's DAILY score, but not better than the player's scores for the WEEKLY or
   * ALL_TIME time spans.
   * The value returned may be {@code null}.
   */
  public java.util.List<PlayerScore> getUnbeatenScores() {
    return unbeatenScores;
  }

  /**
   * The scores in time spans that have not been beaten. As an example, the submitted score may be
   * better than the player's DAILY score, but not better than the player's scores for the WEEKLY or
   * ALL_TIME time spans.
   * The value set may be {@code null}.
   */
  public PlayerScoreResponse setUnbeatenScores(java.util.List<PlayerScore> unbeatenScores) {
    this.unbeatenScores = unbeatenScores;
    return this;
  }

}
